Option Explicit

Global Const G_ARC = 1
Global Const G_CHORD = 2
Global Const G_DRAWTEXT = 3
Global Const G_ELLIPSE = 4
Global Const G_LINE = 5
Global Const G_POLYGON = 6
Global Const G_PIE = 7
Global Const G_POLYLINE = 8
Global Const G_POLYPOLYGON = 9
Global Const G_POLYTEXTOUT = 10
Global Const G_RECTANGLE = 11
Global Const G_ROUNDRECT = 12
Global Const G_TEXTOUT = 13
Global Const G_FREEHAND = 14
Global Const G_GLOBALPIC = 20
Global Const G_PICTURE = 21
Global Const G_DIB = 22
Global Const G_BMP = 23
Global Const G_WMF = 24


' DrawText() Format Flags
Global Const DT_TOP = &H0
Global Const DT_LEFT = &H0
Global Const DT_CENTER = &H1
Global Const DT_RIGHT = &H2
Global Const DT_VCENTER = &H4
Global Const DT_BOTTOM = &H8
Global Const DT_WORDBREAK = &H10
Global Const DT_SINGLELINE = &H20
Global Const DT_EXPANDTABS = &H40
Global Const DT_TABSTOP = &H80
Global Const DT_NOCLIP = &H100
Global Const DT_EXTERNALLEADING = &H200
Global Const DT_CALCRECT = &H400
Global Const DT_NOPREFIX = &H800
Global Const DT_INTERNAL = &H1000

' Common Dialog font flags
Global Const CF_APPLY = &H200&
Global Const CF_ANSIONLY = &H400&
Global Const CF_BOTH = &H3&
Global Const CF_EFFECTS = &H100&            'Specifies that the dialog box should enable strikethrough, underline, and color effects.
Global Const CF_FIXEDPITCHONLY = &H4000&    'Specifies that the dialog box should select only fixed-pitch fonts.
Global Const CF_FORCEFONTEXIST = &H10000    'Specifies that an error message box is displayed if the user attempts to select a font or style that does not exist.
Global Const CF_LIMITSIZE = &H2000&         'Specifies that the dialog box should select only font sizes within the range specified by the Min and Max properties.
Global Const CF_NOSIMULATIONS = &H1000&     'Specifies that the dialog box should not allow GDI (graphic device interface) font simulations.
Global Const CF_NOVECTORFONTS = &H800&      'Specifies that the dialog box should not allow vector-font selections.
Global Const CF_PRINTERFONTS = &H2&         'Causes the dialog box to list only the fonts supported by the printer, specified by the hDC property.
Global Const CF_SCALABLEONLY = &H20000      'Specifies that the dialog box should allow only the selection of fonts that can be scaled.
Global Const CF_SCREENFONTS = &H1&          'Causes the dialog box to list only the screen fonts supported by the system.
Global Const CF_SHOWHELP = &H4&             'Causes the dialog box to display a Help button.
Global Const CF_TTONLY = &H40000            'Specifies that the dialog box should allow only the selection of TrueType fonts.
Global Const CF_WYSIWYG = &H8000&           'Specifies that the dialog box should allow only the selection of fonts that are available on both the printer and the display. If this flag is set, the CF_BOTH and CF_SCALABLEONLY flags should also be set.

' Draw Mode Flags
Global Const R2_BLACK = 1           'Pixel is always black.
Global Const R2_WHITE = 16          'Pixel is always white.
Global Const R2_NOP = 11            'Pixel remains unchanged.
Global Const R2_NOT = 6             'Pixel is the inverse of the screen color.
Global Const R2_COPYPEN = 13        'Pixel is the pen color.
Global Const R2_NOTCOPYPEN = 4      'Pixel is the inverse of the pen color.
Global Const R2_MERGEPENNOT = 14    'Pixel is a combination of the pen color and the inverse of the screen color (final pixel = (~screen pixel) | pen).
Global Const R2_MASKPENNOT = 5      'Pixel is a combination of the colors common to both the pen and the inverse of the screen (final pixel = (~screen pixel) & pen).
Global Const R2_MERGENOTPEN = 12    'Pixel is a combination of the screen color and the inverse of the pen color (final pixel = (~pen) | screen pixel).
Global Const R2_MASKNOTPEN = 3      'Pixel is a combination of the colors common to both the screen and the inverse of the pen (final pixel = (~pen) & screen pixel).
Global Const R2_MERGEPEN = 15       'Pixel is a combination of the pen color and the screen color (final pixel = pen | screen pixel).
Global Const R2_NOTMERGEPEN = 2     'Pixel is the inverse of the R2_MERGEPEN color (final pixel = ~(pen | screen pixel)).
Global Const R2_MASKPEN = 9         'Pixel is a combination of the colors common to both the pen and the screen (final pixel = pen & screen pixel).
Global Const R2_NOTMASKPEN = 8      'Pixel is the inverse of the R2_MASKPEN color (final pixel = ~(pen & screen pixel)).
Global Const R2_XORPEN = 7          'Pixel is a combination of the colors that are in the pen and in the screen, but not in both (final pixel = pen ^ screen pixel).
Global Const R2_NOTXORPEN = 10      'Pixel is the inverse of the R2_XORPEN color (final pixel = ~(pen ^ screen pixel)).

' Background Styles
Global Const BKS_TRANSPARENT = 1
Global Const BKS_OPAQUE = 2

' Fill Styles
Global Const FS_SOLID = 0       ' Solid
Global Const FS_HOLLOW = 1      ' Hollow
Global Const FS_HORLINES = 2    ' Horizontal Lines
Global Const FS_VERTLINES = 3   ' Vertical Lines
Global Const FS_UPDIAG = 4      ' Upward Diagonal
Global Const FS_DOWNDIAG = 5    ' Downward Diagonal
Global Const FS_CROSS = 6       ' Cross
Global Const FS_DIAGCROSS = 7   ' Diagonal Cross

' Border Styles
Global Const BS_SOLID = 0       ' Solid
Global Const BS_DASH = 1        ' Dash
Global Const BS_DOT = 2         ' Dot
Global Const BS_DASHDOT = 3     ' Dash Dot
Global Const BS_DASHDOTDOT = 4  ' Dash Dot Dot
Global Const BS_TRANSPARENT = 5 ' Transparent
Global Const BS_INSIDESOLID = 6 ' Inside Solid

