#ifndef _INC_PRINT
#include <print.h>
#endif

//----------------------
// HighEdit Dialogboxen
//----------------------

#ifdef __cplusplus
extern "C" {
#endif	// __cplusplus

//---------
// Defines
//---------

#define FILETEXT_MAX 4		// Textformate
#define FILEPIC_MAX  6		// Bildformate

#define FILEFORMAT_HIGHEDIT 0
#define FILEFORMAT_ANSI 	1
#define FILEFORMAT_OEM		2
#define FILEFORMAT_RTF		3

#define FILEFORMAT_BITMAP 0
#define FILEFORMAT_PCX	  1
#define FILEFORMAT_GIF	  2
#define FILEFORMAT_TIFF   3
#define FILEFORMAT_TARGA  4
#define FILEFORMAT_WMF	  5

//-------
// Types
//-------

typedef struct
{
	COLORREF cr;
}
COLORBOXPARAM;

typedef COLORBOXPARAM FAR *LPCOLORBOXPARAM;

typedef struct
{
	COLORREF crBk;
	COLORREF crPF;
}
BACKCOLORBOXPARAM;

typedef BACKCOLORBOXPARAM FAR *LPBACKCOLORBOXPARAM;

typedef struct
{
	HWND hwndEdit;
	HFONT hfontThin;
	WORD wWidth;		// Werte in cm * 1000
	WORD wHeight;
	WORD wTop;
	WORD wLeft;
	WORD wBottom;
	WORD wRight;
	WORD wTab;
}
FORMATDOCBOXPARAM;

typedef FORMATDOCBOXPARAM FAR *LPFORMATDOCBOXPARAM;

typedef struct
{
	COLORLOGFONT clf;
	LOCALHANDLE hEnumFont;
	HFONT hfontThin;
	HBITMAP hbmFont[6];
	BOOL bIsScreenFont;
	BOOL bScreenFontsEnabled;
}
FONTBOXPARAM;

typedef FONTBOXPARAM FAR *LPFONTBOXPARAM;

typedef struct
{
	char szPathName [128];
	char szFileName [14];
	char szTextExt [FILETEXT_MAX][6];
	char szPicExt  [FILEPIC_MAX][6];
	WORD wFileType;
	BOOL bSaveBox;
	BOOL bPictureBox;
	HFONT hfontThin;
}
FILEBOXPARAM;

typedef FILEBOXPARAM FAR *LPFILEBOXPARAM;

typedef struct
{
	char szSearchText [128];
	char szReplaceText [128];
	WORD wSearchFlags;
	BOOL bReplaceBox;
	HWND hwndEdit;
	HFONT hfontThin;
	WORD wInternalSearchFlags;
}
SEARCHBOXPARAM;

typedef SEARCHBOXPARAM FAR *LPSEARCHBOXPARAM;

typedef struct
{
	HWND hwndEdit;
	HFONT hfontThin;
}
DOCINFOBOXPARAM;

typedef DOCINFOBOXPARAM FAR *LPDOCINFOBOXPARAM;

typedef struct
{
	HWND hwndEdit;
	HFONT hfontThin;
	GLOBALHANDLE hTab;
	HBITMAP hbmTab[4];
}
PARAGRAPHBOXPARAM;

typedef PARAGRAPHBOXPARAM FAR *LPPARAGRAPHBOXPARAM;

//-----------------------------------------
// Ab Version 3.0
//-----------------------------------------

typedef struct
{
	HWND hwndEdit;
	HFONT hfontThin;
	HFONT hfontThinSetup;
	WORD bfPageNums : 1,
		 bfSetupCancel : 1;
	PRINTDOCPARAM pdp;
	GLOBALHANDLE hDevNames;
	GLOBALHANDLE hDevMode;
}
PRINTBOXPARAM;

typedef PRINTBOXPARAM FAR *LPPRINTBOXPARAM;

//-----------------------------------------

//-----------
// Functions
//-----------

BOOL FAR PASCAL HEDialogInit (HINSTANCE hI);

BOOL FAR PASCAL BackColorDialogBox	  (HWND hwnd, LPBACKCOLORBOXPARAM lpBackColorBoxParam);
int  FAR PASCAL ColorDialogBox		  (HWND hwnd, LPCOLORBOXPARAM lpColorBoxParam);
BOOL FAR PASCAL DocInfoDialogBox	  (HWND hwnd, LPDOCINFOBOXPARAM lpDocInfoBoxParam);
BOOL FAR PASCAL FileAppendDialogBox   (HWND hwnd, LPFILEBOXPARAM lpFileBoxParam);
BOOL FAR PASCAL FileDeleteDialogBox   (HWND hwnd, LPFILEBOXPARAM lpFileBoxParam);
BOOL FAR PASCAL FileOpenDialogBox	  (HWND hwnd, LPFILEBOXPARAM lpFileBoxParam);
BOOL FAR PASCAL FileSaveDialogBox	  (HWND hwnd, LPFILEBOXPARAM lpFileBoxParam);
BOOL FAR PASCAL FontDialogBox		  (HWND hwnd, LPFONTBOXPARAM lpFontBoxParam);
BOOL FAR PASCAL FormatDocDialogBox	  (HWND hwnd, LPFORMATDOCBOXPARAM lpDocumentBoxParam);
BOOL FAR PASCAL ParagraphDialogBox		(HWND hwnd, LPPARAGRAPHBOXPARAM lpParagraphBoxParam);
BOOL FAR PASCAL PictureOpenDialogBox  (HWND hwnd, LPFILEBOXPARAM lpFileBoxParam);
VOID FAR PASCAL QueryReplaceDialogBox (HWND hwnd, LPSEARCHBOXPARAM lpSearchBoxParam);
WORD FAR PASCAL ReplaceDialogBox	  (HWND hwnd, LPSEARCHBOXPARAM lpSearchBoxParam);
BOOL FAR PASCAL SearchDialogBox 	  (HWND hwnd, LPSEARCHBOXPARAM lpSearchBoxParam);

//-----------------------------------------
// Ab Version 3.0
//-----------------------------------------

BOOL FAR PASCAL PrintDialogBox (HWND hwnd, LPPRINTBOXPARAM lpPrintBoxParam);
BOOL FAR PASCAL PrintSetupDialogBox (HWND hwnd, LPPRINTBOXPARAM lpPrintBoxParam);

//-----------------------------------------

#ifdef __cplusplus
}
#endif	// __cplusplus
