/*---------------------------------------------------------------------------*/
/*                                                                           */
/*	 Name:	hetools.h														 */
/*   Autor: Andreas Claus                                                    */
/*	 Datum: 02-Nov-1993 													 */
/*                                                                           */
/*---------------------------------------------------------------------------*/

#ifndef _INC_HETOOLS
#define _INC_HETOOLS	/* #defined if hetools.h has been included */

#ifdef __cplusplus
extern "C" {
#endif	// __cplusplus

//-------
// Ruler
//-------

#define WS_DEFRULER (WS_VISIBLE | WS_CHILD | RS_UNITSCM | RS_HORZ)

#define CLASS_RULER "HEToolsRuler"

// ruler styles

#define RS_UNITSIN		0x0010L
#define RS_UNITSCM		0x0020L
#define RS_UNITSPT		0x0040L
#define RS_HORZ 		0x0080L
#define RS_VERT 		0x0100L

// ruler messages

#define RL_HSCROLL		(WM_USER + 1)
#define RL_SETOFFSET	(WM_USER + 2)
#define RL_VSCROLL		(WM_USER + 3)
#define RL_SETUNIT		(WM_USER + 4)
#define RL_SETREPEAT	(WM_USER + 5)
#define RL_SETMIRROR	(WM_USER + 6)

// ruler notifications

#define RN_LBUTTONDBLCLK   1
#define RN_RBUTTONDBLCLK   2

// ruler units

#define UNIT_CM 	2540
#define UNIT_IN 	1000
#define UNIT_PT 	72

//-----------
// Tabulator
//-----------

#define WS_DEFTAB (WS_CHILD | WS_VISIBLE)

#define CLASS_TAB "HEToolsTab"

// tab types

#define TAB_LEFT         0
#define TAB_RIGHT        1
#define TAB_DECIMAL      2
#define TAB_CENTER       3
#define TAB_LEFTMARGIN   6
#define TAB_RIGHTMARGIN  7
#define TAB_INDENT		 9

// tab units

#define UNIT_CM 	2540
#define UNIT_IN 	1000

// tab messages

#define TM_DELINDENT				(WM_USER + 1)
#define TM_DELLEFTMARGIN            (WM_USER + 2)
#define TM_DELRIGHTMARGIN           (WM_USER + 3)
#define TM_GETLEFTMARGIN            (WM_USER + 4)
#define TM_GETRIGHTMARGIN           (WM_USER + 5)
#define TM_GETPOS                   (WM_USER + 6)
#define TM_SETINDENT				(WM_USER + 9)
#define TM_SETLEFTMARGIN            (WM_USER + 10)
#define TM_SETRIGHTMARGIN           (WM_USER + 11)
#define TM_SETTAB                   (WM_USER + 12)
#define TM_SETTABLIST               (WM_USER + 13)
#define TM_SETOFFSET                (WM_USER + 14)
#define TM_SETPRINTEROFFSET 		(WM_USER + 15)
#define TM_HSCROLL					(WM_USER + 16)
#define TM_GETSCROLLPOS 			(WM_USER + 17)
#define TM_SETUNIT					(WM_USER + 18)
#define TM_GETDISPLAYPOS			(WM_USER + 19)
#define TM_GETTYP					(WM_USER + 20)
#define TM_SETTYP					(WM_USER + 21)
#define TM_GETTABWIDTH				(WM_USER + 22)
#define TM_SETTABWIDTH				(WM_USER + 23)
#define TM_GETINDENT				(WM_USER + 24)


// Nur zum Testen
#define TM_DISPLAYTABSTRUCT 		(WM_USER + 50)

// tab notification codes (internal)

#define TN_INT_ERROR				0xFF
#define TN_INT_INSERT               0x01
#define TN_INT_UPDATE               0x02
#define TN_INT_DELETE               0x03
#define TN_INT_MOUSEMOVE            0x04
#define TN_INT_LEFTSCROLL           0x05
#define TN_INT_RIGHTSCROLL			0x06
#define TN_INT_SCROLLPOS			0x07

// tab notification codes

#define TN_ERROR					0x0000

#define TN_INSERTTAB                0x0100
#define TN_INSERTLEFTTAB			0x0100
#define TN_INSERTRIGHTTAB			0x0101
#define TN_INSERTDECIMALTAB 		0x0102
#define TN_INSERTCENTERTAB			0x0103
#define TN_INSERTLM                 0x0106
#define TN_INSERTRM 				0x0107
#define TN_INSERTINDENT 			0x0109

#define TN_UPDATETAB                0x0200
#define TN_UPDATELEFTTAB			0x0200
#define TN_UPDATERIGHTTAB			0x0201
#define TN_UPDATEDECIMALTAB 		0x0202
#define TN_UPDATECENTERTAB			0x0203
#define TN_UPDATELM                 0x0206
#define TN_UPDATERM 				0x0207
#define TN_UPDATEINDENT 			0x0209

#define TN_DELETETAB				0x0300
#define TN_DELETELEFTTAB			0x0300
#define TN_DELETERIGHTTAB			0x0301
#define TN_DELETEDECIMALTAB 		0x0302
#define TN_DELETECENTERTAB			0x0303

#define TN_MOUSEMOVETAB             0x0400
#define TN_MOUSEMOVELEFTTAB 		0x0400
#define TN_MOUSEMOVERIGHTTAB		0x0401
#define TN_MOUSEMOVEDECIMALTAB		0x0402
#define TN_MOUSEMOVECENTERTAB		0x0403
#define TN_MOUSEMOVELM				0x0406
#define TN_MOUSEMOVERM              0x0407
#define TN_MOUSEMOVEINDENT			0x0409

#define TN_LEFTSCROLLLM             0x0506
#define TN_LEFTSCROLLRM 			0x0507
#define TN_LEFTSCROLLINDENT 		0x0509

#define TN_RIGHTSCROLLLM            0x0606
#define TN_RIGHTSCROLLRM            0x0607
#define TN_RIGHTSCROLLINDENT		0x0609

#define TN_SCROLLPOS				0x0700

// Ungltiger Offset

#define TABOFFSET_ERROR 0x8000000

// Ermittlung der Koordinaten aus einem Rckgabepuffer

#define TAB_GETUNITPOS(a)		(*((LONG FAR *) (a)))
#define TAB_GETPRINTERPOS(a)	((LONG) (*(((LONG FAR *) (a)) + 1)))

#define TAB_SCROLLAMOUNT 2

//--------
// Status
//--------

#define WS_DEFSTATUS (WS_CHILD | WS_VISIBLE)

#define CLASS_STATUS "HEToolsStatus"

#define SL_MINWIDTH 		(WM_USER + 1)
#define SL_SETITEM			(WM_USER + 2)
#define SL_SETITEMTEXT	    (WM_USER + 3)
#define SL_DISPLAYMENUTEXT  (WM_USER + 4)
#define SL_REMOVEMENUTEXT   (WM_USER + 5)
#define SL_GETHEIGHT	    (WM_USER + 6)
#define SL_DISPLAYTEXT		(WM_USER + 7)

//--------
// Button
//--------

#define WS_DEFBUTTON (WS_VISIBLE | WS_CHILD)

#define CLASS_BUTTON "HEToolsButton"

#define BS_DIALOG 0x0000000010

#define BUTTONTEXT_ENABLE  1
#define BUTTONTEXT_DISABLE 2
#define BUTTONTEXT_GRAY    4

#define BUTTONBITMAP_ENABLE  1
#define BUTTONBITMAP_DISABLE 2
#define BUTTONBITMAP_GRAY	 4

#define BGM_SETTEXT 	 (WM_USER + 1)
#define BGM_SETBITMAP	 (WM_USER + 2)
#define BGM_GETACTIVE	 (WM_USER + 3)
#define BGM_GETCHECK	 (WM_USER + 4)
#define BGM_SETCHECK	 (WM_USER + 5)
#define BGM_SETCREATE	 (WM_USER + 6)
#define BGM_CHARPRESSED  (WM_USER + 7)
#define BGM_SETFONT 	 (WM_USER + 8)
#define BGM_ENABLE		 (WM_USER + 9)

#define BGN_ERROR			0
#define BGN_CLICKED 		1
#define BGN_DOUBLECLICKED	2

#define BTC_OPTIMIZEFIT 	1
#define BTC_BESTFIT 		2
#define BTC_AND 			4
#define BTC_OR				8
#define BTC_NAND			16
#define BTC_NORMAL			32
#define BTC_THICKFRAME		64
#define BTC_NOTADJUST		128 	// Buttongruppe wird bei WM_SIZE nicht neu ausgerichtet
#define BTC_FOCUSFRAME		256 	// Rahmen um Button mit Focus
#define BTC_NOFOCUSRECT 	512 	// Kein FocusRectangle innerhalb Button

#define BTI_PRESSED 		1
#define BTI_ACTIVE			2

#define BT_TEXTLENGTH		30

#define BT_LEFTBORDER		3
#define BT_RIGHTBORDER		2
#define BT_TOPBORDER		3
#define BT_BOTTOMBORDER 	2

#define BT_BMPSTARTX  3 				// TOP/DOWN/LEFT/RIGHT
#define BT_BMPSTARTY  3
#define BT_TXTSTARTX  3
#define BT_TXTSTARTY  3

#define BTB_LEFT	1		   //Ausrichtung fr Bitmap
#define BTB_RIGHT	2
#define BTB_TOP 	4
#define BTB_BOTTOM	8
#define BTB_HCENTER 16
#define BTB_VCENTER 32

#define BTT_LEFT	1		   //Ausrichtung fr Text
#define BTT_RIGHT	2
#define BTT_TOP 	4
#define BTT_BOTTOM	8
#define BTT_HCENTER 16
#define BTT_VCENTER 32
#define BTT_NOWORDBREAK 64

#ifndef RC_INVOKED

typedef struct stButtonCreate
{
	BYTE byCount;					// Anzahl der Buttons
	BYTE byType;
	WORD wStyle;				  // 1 = Best, 0 = Opti, 2 = AND, 4 = OR, 8 = NORMAL
	WORD wWidth;
	WORD wHeight;
}
BUTTONCREATE;

typedef BUTTONCREATE FAR *LPBUTTONCREATE;

typedef struct stButtonInfo
{
	WORD wStatus;					// 0 = nicht gedrckt, 1 = gedrckt
									// 2 = aktive, 4 = inactive
	char szText [BT_TEXTLENGTH];
	HBITMAP hBitmap [2];			// 0 = Actives Bitmap , 1 = Inactives Bitmap
	WORD wAlignBmp;
	WORD wAlignText;

}
BUTTONINFO;

#endif // RC_INVOKED

typedef BUTTONINFO FAR *LPBUTTONINFO;

#define BUTTONGROUPSIZE(a)	   (sizeof (BUTTONCREATE) + (sizeof (BUTTONINFO) * (a)))

//------------
// Tools Init
//------------

BOOL FAR PASCAL HEToolsInit (HANDLE);


#ifdef __cplusplus
}
#endif	// __cplusplus

#endif // _INC_HETOOLS
