// hevcdlg.cpp : implementation file
//

#include "stdafx.h"

#include "highdoc.h"
#include "highvw.h"
#include "highfrm.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


class CHighFrame;

inline CHighFrame* GetFrameWnd ()
{
    return (CHighFrame *) (AfxGetApp()->m_pMainWnd);
}



/////////////////////////////////////////////////////////////////////////////
// CHEDialogBoxes construction/destruction

CHEDialogBoxes::CHEDialogBoxes()
              : m_pHighView(NULL)
{
    memset (&m_FontBoxParam, 0, sizeof (m_FontBoxParam));
    memset (&m_ColorBoxParam, 0, sizeof (m_ColorBoxParam));
    memset (&m_FileBoxParam, 0, sizeof (m_FileBoxParam));
    memset (&m_PictureFileBoxParam, 0, sizeof (m_PictureFileBoxParam));
    memset (&m_SearchBoxParam, 0, sizeof (m_SearchBoxParam));
    memset (&m_DocInfoBoxParam, 0, sizeof (m_DocInfoBoxParam));
    memset (&m_FormatDocBoxParam, 0, sizeof (m_FormatDocBoxParam));
    memset (&m_BackColorBoxParam, 0, sizeof (m_BackColorBoxParam));
    memset (&m_ParagraphBoxParam, 0, sizeof (m_ParagraphBoxParam));
    memset (&m_PrintBoxParam, 0, sizeof (m_PrintBoxParam));
    
    m_FileBoxParam.wFileType = FILEFORMAT_HIGHEDIT;
    m_SearchBoxParam.wSearchFlags = SEARCH_INIT;
    m_BackColorBoxParam.crBk = RGB_WHITE;
    m_BackColorBoxParam.crPF = RGB_LTGRAY;
}

CHEDialogBoxes::~CHEDialogBoxes()
{
}

/////////////////////////////////////////////////////////////////////////////
// CHEDialogBoxes operations

VOID CHEDialogBoxes::SetHighEditView (CHighView *pHighView)
{
    m_pHighView = pHighView;
    m_SearchBoxParam.hwndEdit = pHighView->m_pHighEdit->m_hWnd;
    m_FormatDocBoxParam.hwndEdit = pHighView->m_pHighEdit->m_hWnd;
    m_DocInfoBoxParam.hwndEdit = pHighView->m_pHighEdit->m_hWnd;
    m_ParagraphBoxParam.hwndEdit = pHighView->m_pHighEdit->m_hWnd;
    m_PrintBoxParam.hwndEdit = pHighView->m_pHighEdit->m_hWnd;
}

BOOL CHEDialogBoxes::LoadDlg()
{
    BOOL bReturn = FALSE;
    
    if (FileOpenDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_FileBoxParam))
        bReturn = LoadFile ();
        
    return bReturn;
}

BOOL CHEDialogBoxes::LoadFile()
{
    WORD wMessage = HE_LOADDATA;
    char szPathFile [256];

    lstrcpy (szPathFile, m_FileBoxParam.szPathName);
    lstrcat (szPathFile, m_FileBoxParam.szFileName);

    switch (m_FileBoxParam.wFileType)
    {
        case FILEFORMAT_ANSI:
            wMessage = HE_LOADANSI;
            break;

        case FILEFORMAT_OEM:
            wMessage = HE_LOADOEM;
            break;

        case FILEFORMAT_RTF:
            wMessage = HE_LOADRTF;
            break;
    }

    return (BOOL) m_pHighView->m_pHighEdit->SendMessage (wMessage, 0, (LONG) (LPSTR) szPathFile);
}

BOOL CHEDialogBoxes::AppendDlg()
{
    BOOL bReturn = FALSE;
    
    if (FileAppendDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_FileBoxParam))
        bReturn = AppendFile ();
        
    return bReturn;
}

BOOL CHEDialogBoxes::AppendFile ()
{
    WORD wMessage = HE_APPENDDATA;
    char szPathFile [256];

    lstrcpy (szPathFile, m_FileBoxParam.szPathName);
    lstrcat (szPathFile, m_FileBoxParam.szFileName);

    switch (m_FileBoxParam.wFileType)
    {
        case FILEFORMAT_ANSI:
            wMessage = HE_APPENDANSI;
            break;

        case FILEFORMAT_OEM:
            wMessage = HE_APPENDOEM;
            break;

        case FILEFORMAT_RTF:
            wMessage = HE_APPENDRTF;
            break;
    }

    return (BOOL) m_pHighView->m_pHighEdit->SendMessage (wMessage, 0, (LONG) (LPSTR) szPathFile);
}

BOOL CHEDialogBoxes::SaveDlg ()
{
    BOOL bReturn = FALSE;

    if (FileSaveDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_FileBoxParam))
        bReturn = SaveFile ();
        
    return (bReturn);
}

BOOL CHEDialogBoxes::SaveFile ()
{
    WORD wMessage = HE_SAVEDATA;
    char szPathFile [256];

    lstrcpy (szPathFile, m_FileBoxParam.szPathName);
    lstrcat (szPathFile, m_FileBoxParam.szFileName);

    switch (m_FileBoxParam.wFileType)
    {
        case FILEFORMAT_ANSI:
            wMessage = HE_SAVEANSI;
            break;

        case FILEFORMAT_OEM:
            wMessage = HE_SAVEOEM;
            break;

        case FILEFORMAT_RTF:
            wMessage = HE_SAVERTF;
            break;
    }

    return (BOOL) m_pHighView->m_pHighEdit->SendMessage (wMessage, OF_DEFHESAVE, (LONG) (LPSTR) szPathFile);
}


BOOL CHEDialogBoxes::ParagraphDlg()
{                                   
    return ParagraphDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_ParagraphBoxParam);
}

BOOL CHEDialogBoxes::FontDlg()
{
    CHighEdit *pHighEdit = m_pHighView->m_pHighEdit;
    BOOL bFlag;

    m_FontBoxParam.bIsScreenFont = (BOOL) pHighEdit->SendMessage (HE_ISSCREENFONT, (WORD) -1, 0L);

    if (m_FontBoxParam.bIsScreenFont)
        pHighEdit->SendMessage (HE_GETSCREENCOLORLOGFONT, (WORD) -1
                  , (LONG) (LPSTR) &m_FontBoxParam.clf);
    else
        pHighEdit->SendMessage (HE_GETCOLORLOGFONT, (WORD) -1
                  , (LONG) (LPSTR) &m_FontBoxParam.clf);

    m_FontBoxParam.bScreenFontsEnabled = (BOOL) pHighEdit->SendMessage (HE_ISSCREENFONTSENABLED, 0, 0L);

    if (bFlag = FontDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_FontBoxParam))
    {
        pHighEdit->SendMessage (HE_ENABLESCREENFONTS, m_FontBoxParam.bScreenFontsEnabled, 0L);
        GetFrameWnd()->m_pHEIcon->SendMessage (IBM_ENABLESCREENFONTS, m_FontBoxParam.bScreenFontsEnabled, 0L);

        if (m_FontBoxParam.bIsScreenFont)
            pHighEdit->SendMessage (HE_SETCOLORLOGFONT
                       , FONT_DISPLAY | FONT_SET_ALL
                       , (LONG) (LPSTR) &m_FontBoxParam.clf);
        else
            pHighEdit->SendMessage (HE_SETCOLORLOGFONT
                       , FONT_PRINTER | FONT_SET_ALL
                       , (LONG) (LPSTR) &m_FontBoxParam.clf);
    }

    return (bFlag);
}
                                 
BOOL CHEDialogBoxes::PictureDlg ()
{
    BOOL bReturn = FALSE;

    if (PictureOpenDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_PictureFileBoxParam))
    {
        WORD wMessage = HE_LOADBITMAP;
        char szPathFile [256];

        lstrcpy (szPathFile, m_PictureFileBoxParam.szPathName);
        lstrcat (szPathFile, m_PictureFileBoxParam.szFileName);

        switch (m_PictureFileBoxParam.wFileType)
        {
            case FILEFORMAT_BITMAP:
                wMessage = HE_LOADBITMAP;
                break;
            case FILEFORMAT_PCX:
                wMessage = HE_LOADPCX;
                break;
            case FILEFORMAT_GIF:
                wMessage = HE_LOADGIF;
                break;
            case FILEFORMAT_TIFF:
                wMessage = HE_LOADTIFF;
                break;
            case FILEFORMAT_TARGA:
                wMessage = HE_LOADTARGA;
                break;
            case FILEFORMAT_WMF:
                wMessage = HE_LOADWMF;
                break;
        }

        bReturn = (BOOL) m_pHighView->m_pHighEdit->SendMessage (wMessage, BMP_SCALE, (LONG) (LPSTR) szPathFile);
    }

    return (bReturn);
}


WORD CHEDialogBoxes::ReplaceDlg()
{
    CHighEdit *pHighEdit = m_pHighView->m_pHighEdit;
    WORD wReturn = ReplaceDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_SearchBoxParam);

    switch (wReturn)
    {
        case 1:
            // Ersetzen mit Rckfrage

            if (Search (m_SearchBoxParam.wSearchFlags, m_SearchBoxParam.szSearchText, TRUE) == SEARCH_FOUND)
                QueryReplaceDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_SearchBoxParam);

            break;

        case 2:
            // Alles ersetzen

            {
                LONG lCursorPos;
                DWORD dwYPos;
                WORD wXPos;

                pHighEdit->SendMessage (WM_SETREDRAW, FALSE, 0L);

                if (Search (m_SearchBoxParam.wSearchFlags, m_SearchBoxParam.szSearchText, TRUE) == SEARCH_FOUND)
                {
                    do
                    {
                        lCursorPos = pHighEdit->SendMessage (HE_GETCURSOR, 0, 0L);
                        dwYPos = GETYPOS (lCursorPos);
                        wXPos = GETXPOS (lCursorPos);

                        pHighEdit->SendMessage (HE_REPLACESEL, 0, (LONG) (LPSTR) m_SearchBoxParam.szReplaceText);

                        m_SearchBoxParam.wSearchFlags |= (SEARCH_CURSOR | SEARCH_INIT);

                        if (m_SearchBoxParam.wSearchFlags & SEARCH_BACK)
                            pHighEdit->SendMessage (HE_SETCURSOR, wXPos, dwYPos);
                    }
                    while (SearchContinue (FALSE, TRUE) == SEARCH_FOUND);
                }

                m_SearchBoxParam.wSearchFlags = m_SearchBoxParam.wInternalSearchFlags;
                m_SearchBoxParam.wSearchFlags |= SEARCH_INIT;

                pHighEdit->SendMessage (WM_SETREDRAW, TRUE, 0L);
            }

            break;
    }

    return (wReturn);
}


BOOL CHEDialogBoxes::SearchDlg ()
{
    BOOL bFlag = SearchDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_SearchBoxParam);

    if (bFlag)
        if (Search (m_SearchBoxParam.wSearchFlags, m_SearchBoxParam.szSearchText, TRUE) != SEARCH_FOUND)
            bFlag = FALSE;
            
    return (bFlag);
}

WORD CHEDialogBoxes::Search (WORD wFlags, LPSTR pText, BOOL bDisplayError) 
{
    WORD wReturn = (WORD) m_pHighView->m_pHighEdit->SendMessage (HE_SEARCH, wFlags, (LONG) (LPSTR) pText);


    switch (wReturn)
    {
        case SEARCH_ERROR:
            m_SearchBoxParam.wSearchFlags |= SEARCH_INIT;


        case SEARCH_NOTFOUND:
            m_SearchBoxParam.wSearchFlags |= SEARCH_INIT;
            break;

        case SEARCH_FOUND:
            m_SearchBoxParam.wSearchFlags &= ~SEARCH_INIT;
            break;
    }

    return (wReturn);
}

WORD CHEDialogBoxes::SearchContinue (BOOL bDisplayError, BOOL bIgnoreInit)
{
    WORD wReturn = FALSE;

    if (!bIgnoreInit && m_SearchBoxParam.wSearchFlags & SEARCH_INIT)
        wReturn = SEARCH_ERROR;
    else
    {
        wReturn = (WORD) m_pHighView->m_pHighEdit->SendMessage (HE_SEARCH,
                                      m_SearchBoxParam.wSearchFlags,
                                      (LONG) (LPSTR) m_SearchBoxParam.szSearchText);

        switch (wReturn)
        {
            case SEARCH_NOTFOUND:
                m_SearchBoxParam.wSearchFlags |= SEARCH_INIT;
                break;

            case SEARCH_ERROR:
                m_SearchBoxParam.wSearchFlags |= SEARCH_INIT;
                break;

            case SEARCH_FOUND:
                m_SearchBoxParam.wSearchFlags &= ~SEARCH_INIT;
                break;
        }
    }

    return (wReturn);
}

BOOL CHEDialogBoxes::FormatDocDlg ()
{
    return FormatDocDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_FormatDocBoxParam);
}


BOOL CHEDialogBoxes::DocInfoDlg ()
{
    return DocInfoDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_DocInfoBoxParam);
}


int CHEDialogBoxes::ColorDlg ()
{
    int iReturn;

    m_ColorBoxParam.cr = m_pHighView->m_pHighEdit->SendMessage (HE_GETRGB, (WORD) -1, 0L);
    iReturn = ColorDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_ColorBoxParam);

    if (iReturn != -1)
        m_pHighView->m_pHighEdit->SendMessage (HE_SETSTYLE, CURRENT_ATTRIBUTE, m_ColorBoxParam.cr);

    return (iReturn);
}


VOID CHEDialogBoxes::BkColorDlg ()
{
    if (BackColorDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_BackColorBoxParam))
    {
        CHighEdit *pHighEdit = m_pHighView->m_pHighEdit;
    
        delete m_pHighView->m_pBrushBk;

        if (m_pHighView->m_pBrushBk = new CBrush ())
            m_pHighView->m_pBrushBk->CreateSolidBrush (m_BackColorBoxParam.crBk);
            
        pHighEdit->SendMessage (HE_SETPFBKCOLOR, 0, m_BackColorBoxParam.crPF);

        pHighEdit->InvalidateRect (NULL, TRUE);

        if (pHighEdit->SendMessage (HE_ISHEADFOOTVISIBLE, 0, 0L))
        {
            LONG lHwnd = pHighEdit->SendMessage (HE_GETHEADFOOTHWND, 0, 0L);

            ::InvalidateRect ((HWND) LOWORD (lHwnd), NULL, TRUE);
            ::InvalidateRect ((HWND) HIWORD (lHwnd), NULL, TRUE);
        }

        pHighEdit->UpdateWindow ();
    }
}

BOOL CHEDialogBoxes::PrintDlg()
{   

   if (PrintDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_PrintBoxParam))
    {
        char szTitle[20];

        m_pHighView->GetWindowText (szTitle, sizeof (szTitle));

        m_PrintBoxParam.pdp.lpDocTitle = szTitle;

        m_pHighView->m_pHighEdit->SendMessage (HE_PRINTDOCUMENT, PRINT_FULLDOCUMENTABORTDLG, (LONG) (LPSTR) &m_PrintBoxParam.pdp);
        
        ::DeleteDC (m_PrintBoxParam.pdp.hdc);
        return TRUE;
    }
            
    return FALSE;
}


BOOL CHEDialogBoxes::PrintSetupDlg()
{
    return PrintSetupDialogBox (m_pHighView->GetParentFrame()->m_hWnd, &m_PrintBoxParam);
    
    return(TRUE);
}


