// highvw.cpp : implementation of the CHighView class
//

#include "hetools.h"
#include "stdafx.h"
#include "highvcpp.h"

#include "resource.h"

#include "highdoc.h"
#include "highvw.h"
#include "highfrm.h" 
#include "hefins.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTableDlg dialog (used by CHighView)

class CTableDlg : public CDialog
{
// Construction
public:
	CTableDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTableDlg)
	enum { IDD = IDD_TABLEINSERT };
	UINT	m_Rows;
	UINT	m_Columns;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CTableDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTableDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CTableDlg::CTableDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CTableDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CTableDlg)
    m_Rows = 0;
    m_Columns = 0;
    //}}AFX_DATA_INIT
}

void CTableDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CTableDlg)
    DDX_Text(pDX, IDC_ROWS, m_Rows);
    DDX_Text(pDX, IDC_COLUMNS, m_Columns);
    DDV_MinMaxUInt(pDX, m_Columns, 1, 255);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTableDlg, CDialog)
    //{{AFX_MSG_MAP(CTableDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTableDlg message handlers

BOOL CTableDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
    
    // TODO: Add extra initialization here

    m_Rows    = 1;
    m_Columns = 1;
    
    UpdateData (FALSE);    
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CHighView

IMPLEMENT_DYNCREATE(CHighView, CView)

BEGIN_MESSAGE_MAP(CHighView, CView)
    //{{AFX_MSG_MAP(CHighView)
    ON_WM_CREATE()
    ON_WM_DESTROY()
    ON_WM_SIZE()
    ON_HEM_DBLCLK(ID_HIGHEDIT, OnDblClk)
    ON_HEM_TABMODIFY(ID_HIGHEDIT, OnTabModify)
    ON_HEM_HSCROLL(ID_HIGHEDIT, OnHScroll)
    ON_HEM_FONTSIZE(ID_HIGHEDIT, OnFontSize) 
    ON_HEM_SELECTPF(ID_HIGHEDIT, OnSelectPf)
    ON_HEM_FONT(ID_HIGHEDIT, OnFont)
    ON_HEM_CURSORPOS(ID_HIGHEDIT, OnCursorPos)
    ON_TN_INSERTLEFTTAB(ID_TAB, OnTabInsert)
    ON_TN_UPDATELEFTTAB(ID_TAB, OnTabUpdate)
    ON_TN_UPDATELM(ID_TAB, OnLMUpdate)
    ON_TN_UPDATERM(ID_TAB, OnRMUpdate)
    ON_TN_UPDATEINDENT(ID_TAB, OnIndentUpdate)
    ON_TN_DELETELEFTTAB(ID_TAB, OnTabDelete)
    ON_IBN_DBLCLK(ID_ICON, OnIconDblClk)
    ON_IBN_TAB(ID_ICON, OnIconTab)
    ON_IBN_FONTNAME(ID_ICON, OnIconFontName)
    ON_IBN_FONTSIZE(ID_ICON, OnIconFontSize)
    ON_IBN_DISPLAY(ID_ICON, OnIconDisplay)
    ON_IBN_COLOR(ID_ICON, OnIconColor)                         
    ON_RN_LBUTTONDBLCLK(ID_RULER, OnRulerDblClk)
    ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
    ON_COMMAND(ID_FILE_INSERT, OnFileInsert)
    ON_WM_SETFOCUS()
    ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
    ON_COMMAND(ID_FILE_INFO, OnFileInfo)
    ON_COMMAND(ID_FILE_SAVE, OnFileSave)
    ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
    ON_COMMAND(ID_WINDOW_HEADFOOT, OnWindowHeadFoot)
    ON_COMMAND(ID_WINDOW_PREVIEW, OnWindowPreview)
    ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
    ON_COMMAND(ID_FILE_PRINTSETUP, OnFilePrintSetup)
    ON_COMMAND(ID_SPECIAL_INSERTTABLE, OnSpecialInsertTable)
    ON_COMMAND(ID_SPECIAL_INSERTROW, OnSpecialInsertRow)
    ON_COMMAND(ID_SPECIAL_DELETEROW, OnSpecialDeleteRow)
    ON_HEM_STYLE(ID_HIGHEDIT, OnStyle)
    ON_HEM_ALIGN(ID_HIGHEDIT, OnAlign)
    ON_HEM_SPACING(ID_HIGHEDIT, OnSpacing)
    ON_IBN_STYLE(ID_ICON, OnIconStyle)
    ON_IBN_SPACING(ID_ICON, OnIconSpacing)
    ON_IBN_ALIGN(ID_ICON, OnIconAlign)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_COMMAND(ID_FONT_BOLD, OnFontBold)
	ON_COMMAND(ID_FONT_CENTER, OnFontCenter)
	ON_COMMAND(ID_FONT_COLOR, OnFontColor)
	ON_COMMAND(ID_FONT_FLUSHLEFT, OnFontFlushleft)
	ON_COMMAND(ID_FONT_FLUSHRIGHT, OnFontFlushright)
	ON_COMMAND(ID_FONT_ITALIC, OnFontItalic)
	ON_COMMAND(ID_FONT_JUSTIFY, OnFontJustify)
	ON_COMMAND(ID_FONT_NEWFONT, OnFontNewfont)
	ON_COMMAND(ID_FONT_SCREENFONTS, OnFontScreenfonts)
	ON_COMMAND(ID_FONT_SPACINGDOUBLE, OnFontSpacingdouble)
	ON_COMMAND(ID_FONT_SPACINGONE, OnFontSpacingone)
	ON_COMMAND(ID_FONT_SPACINGONEHALF, OnFontSpacingonehalf)
	ON_COMMAND(ID_FONT_STANDARD, OnFontStandard)
	ON_COMMAND(ID_FONT_STRIKEOUT, OnFontStrikeout)
	ON_COMMAND(ID_FONT_SUBSCRIPT, OnFontSubscript)
	ON_COMMAND(ID_FONT_SUPERSCRIPT, OnFontSuperscript)
	ON_COMMAND(ID_FONT_UNDERLINE, OnFontUnderline)
	ON_COMMAND(ID_REPLACE, OnReplace)
	ON_COMMAND(ID_SEARCH, OnSearch)
	ON_COMMAND(ID_SEARCH_CONTINUE, OnSearchContinue)
	ON_COMMAND(ID_OPT_BACKCOLOR, OnOptBackcolor)
	ON_COMMAND(ID_OPT_CRVISIBLE, OnOptCrvisible)
	ON_COMMAND(ID_OPT_DOCFORMAT, OnOptDocformat)
	ON_COMMAND(ID_OPT_GRAYBK, OnOptGraybk)
	ON_COMMAND(ID_OPT_LINEBREAK, OnOptLinebreak)
	ON_COMMAND(ID_OPT_LINEGHOST, OnOptLineghost)
	ON_COMMAND(ID_OPT_PARAGRAPH, OnOptParagraph)
	ON_COMMAND(ID_OPT_PFFUNCTION, OnOptPffunction)
	ON_COMMAND(ID_OPT_PFGHOST, OnOptPfghost)
	ON_COMMAND(ID_OPT_PFVISIBLE, OnOptPfvisible)
	ON_COMMAND(ID_OPT_PICTUREFRAME, OnOptPictureframe)
	ON_COMMAND(ID_OPT_SAVEOPTIONS, OnOptSaveoptions)
	ON_COMMAND(ID_OPT_SPACEVISIBLE, OnOptSpacevisible)
	ON_COMMAND(ID_OPT_TABVISIBLE, OnOptTabvisible)
	ON_COMMAND(ID_OPT_UNITCM, OnOptUnitcm)
	ON_COMMAND(ID_OPT_UNITIN, OnOptUnitin)
	ON_COMMAND(ID_SPECIAL_FORMAT, OnSpecialFormat)
	ON_COMMAND(ID_SPECIAL_FORMFEED, OnSpecialFormfeed)
	ON_COMMAND(ID_SPECIAL_INSERTPICTURE, OnSpecialInsertpicture)
	ON_COMMAND(ID_SPECIAL_PAGINATE, OnSpecialPaginate)
	ON_COMMAND(ID_WINDOW_CLOSEALL, OnWindowCloseall)
	ON_UPDATE_COMMAND_UI(ID_FONT_BOLD, OnUpdateFontBold)
	ON_UPDATE_COMMAND_UI(ID_FONT_CENTER, OnUpdateFontCenter)
	ON_UPDATE_COMMAND_UI(ID_FONT_FLUSHLEFT, OnUpdateFontFlushleft)
	ON_UPDATE_COMMAND_UI(ID_FONT_FLUSHRIGHT, OnUpdateFontFlushright)
	ON_UPDATE_COMMAND_UI(ID_FONT_ITALIC, OnUpdateFontItalic)
	ON_UPDATE_COMMAND_UI(ID_FONT_JUSTIFY, OnUpdateFontJustify)
	ON_UPDATE_COMMAND_UI(ID_FONT_SPACINGDOUBLE, OnUpdateFontSpacingdouble)
	ON_UPDATE_COMMAND_UI(ID_FONT_SPACINGONE, OnUpdateFontSpacingone)
	ON_UPDATE_COMMAND_UI(ID_FONT_SPACINGONEHALF, OnUpdateFontSpacingonehalf)
	ON_UPDATE_COMMAND_UI(ID_FONT_STRIKEOUT, OnUpdateFontStrikeout)
	ON_UPDATE_COMMAND_UI(ID_FONT_SUBSCRIPT, OnUpdateFontSubscript)
	ON_UPDATE_COMMAND_UI(ID_FONT_SUPERSCRIPT, OnUpdateFontSuperscript)
	ON_UPDATE_COMMAND_UI(ID_FONT_UNDERLINE, OnUpdateFontUnderline)
	ON_UPDATE_COMMAND_UI(ID_FONT_SCREENFONTS, OnUpdateFontScreenfonts)
	ON_UPDATE_COMMAND_UI(ID_OPT_GRAYBK, OnUpdateOptGraybk)
	ON_UPDATE_COMMAND_UI(ID_OPT_CRVISIBLE, OnUpdateOptCrvisible)
	ON_UPDATE_COMMAND_UI(ID_OPT_SPACEVISIBLE, OnUpdateOptSpacevisible)
	ON_UPDATE_COMMAND_UI(ID_OPT_TABVISIBLE, OnUpdateOptTabvisible)
	ON_UPDATE_COMMAND_UI(ID_OPT_UNITCM, OnUpdateOptUnitcm)
	ON_UPDATE_COMMAND_UI(ID_OPT_UNITIN, OnUpdateOptUnitin)
	ON_UPDATE_COMMAND_UI(ID_OPT_PICTUREFRAME, OnUpdateOptPictureframe)
	ON_UPDATE_COMMAND_UI(ID_OPT_PFVISIBLE, OnUpdateOptPfvisible)
	ON_UPDATE_COMMAND_UI(ID_OPT_PFGHOST, OnUpdateOptPfghost)
	ON_UPDATE_COMMAND_UI(ID_OPT_PFFUNCTION, OnUpdateOptPffunction)
	ON_UPDATE_COMMAND_UI(ID_OPT_LINEBREAK, OnUpdateOptLinebreak)
	ON_UPDATE_COMMAND_UI(ID_OPT_LINEGHOST, OnUpdateOptLineghost)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_HEADFOOT, OnUpdateWindowHeadfoot)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_PREVIEW, OnUpdateWindowPreview)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
    ON_TN_INSERTRIGHTTAB(ID_TAB, OnTabInsert)
    ON_TN_INSERTDECIMALTAB(ID_TAB, OnTabInsert)
    ON_TN_INSERTCENTERTAB(ID_TAB, OnTabInsert)
    ON_TN_UPDATERIGHTTAB(ID_TAB, OnTabUpdate)
    ON_TN_UPDATEDECIMALTAB(ID_TAB, OnTabUpdate)
    ON_TN_UPDATECENTERTAB(ID_TAB, OnTabUpdate)
    ON_TN_DELETERIGHTTAB(ID_TAB, OnTabDelete)
    ON_TN_DELETEDECIMALTAB(ID_TAB, OnTabDelete)
    ON_TN_DELETECENTERTAB(ID_TAB, OnTabDelete)
    ON_RN_RBUTTONDBLCLK(ID_RULER, OnRulerDblClk)
	ON_COMMAND(ID_SPECIAL_INSERTFIELD, OnSpecialInsertfield)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHighView construction/destruction

CHighView::CHighView()
         : m_pBrushBk(NULL)
         , m_bUntitled(TRUE)
{

 byAlign=0;
 byStyle=0;
 bySpacing=0;

 
   

}

CHighView::~CHighView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CHighView operations
   
   
/////////////////////////////////////////////////////////////////////////////
// CHighView drawing

void CHighView::OnDraw(CDC* pDC)
{
    CHighDoc* pDoc = GetDocument();

    
}



/////////////////////////////////////////////////////////////////////////////
// CHighView diagnostics

#ifdef _DEBUG
void CHighView::AssertValid() const
{
    CView::AssertValid();
}

void CHighView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CHighDoc* CHighView::GetDocument() // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHighDoc)));
    return (CHighDoc*) m_pDocument;
}

#endif //_DEBUG

// -------------------------------------------------------------------------------------
                                                                   
void CHighView::SetAlign(BYTE Align,BOOL HighEdit,BOOL IconBar)
{
 byAlign=Align;
 if(HighEdit)m_pHighEdit->SendMessage (HE_SETALIGN, byAlign, 0L);
 if (IconBar &&(GetFrameWnd()->m_pHEIcon))
     GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETALIGN, byAlign, 0L);
};

void CHighView::SetStyle(BYTE Style,BOOL HighEdit,BOOL IconBar)
{
 byStyle=Style;
 if(HighEdit) m_pHighEdit->SendMessage (HE_SETSTYLE,byStyle, CURRENT_COLOR);
 if (IconBar &&(GetFrameWnd()->m_pHEIcon))
     GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETSTYLE, byStyle, 0L);
};

void CHighView::ToggleStyle(BYTE Style,BOOL HighEdit,BOOL IconBar)
{
 BYTE NewStyle=byStyle;
 if(Style==ATTR_STANDARD) NewStyle=ATTR_STANDARD;
 else {
  if(NewStyle & Style) NewStyle -= Style; // nur angegebenen(!) Style zurcksetzen   
  else {
   NewStyle |=Style; // Style zustzlich(!) zu bisherigen Styles setzen 
   if(Style==ATTR_SUBSCRIPT) NewStyle&=~ATTR_SUPERSCRIPT; // Subscript schaltet Superscript aus
   if(Style==ATTR_SUPERSCRIPT) NewStyle&=~ATTR_SUBSCRIPT; // Superscript schaltet Subscript aus
  };
 };
 SetStyle(NewStyle,HighEdit,IconBar);
};

void CHighView::SetSpacing(BYTE Spacing,BOOL HighEdit,BOOL IconBar)
{
 bySpacing=Spacing;
 if(HighEdit) m_pHighEdit->SendMessage (HE_SETSPACING, bySpacing, 0L);
 if (IconBar &&(GetFrameWnd()->m_pHEIcon))
     GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETSPACING, bySpacing, 0L);
};
                                                                   

/////////////////////////////////////////////////////////////////////////////
// CHighView message handlers

int CHighView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (CView::OnCreate(lpCreateStruct) == -1)
        return -1;
    
    
                  
    if (m_pHETab = new CHETabulator ())
    {
        m_pHETab->Create (WS_DEFTAB, CRect (), this, ID_TAB);
        m_pHETab->SendMessage (TM_SETOFFSET, FALSE, 15L);
    }
                      
    if (m_pHERuler = new CHERuler ())
    {
        m_pHERuler->Create (WS_DEFRULER, CRect (), this, ID_RULER);
        m_pHERuler->SendMessage (RL_SETOFFSET, FALSE, -15L);
    }
        
    if (m_pHighEdit = new CHighEdit ())
    {
        m_pHighEdit->Create (WS_DEFHIGHEDIT | WS_VSCROLL | WS_HSCROLL | WS_BORDER | HS_HEADFOOT | HS_UNDO
                           , CRect (), this, ID_HIGHEDIT);

        m_pHighEdit->SendMessage (HE_SETOFFSET, FALSE, MAKELONG (15, 5));
        m_pHighEdit->SetFocus ();
        
        if (m_pHETab)
            m_pHETab->SendMessage (TM_SETTABWIDTH
                               , (WORD) m_pHighEdit->SendMessage (HE_GETTABWIDTH, 0, 0L), 0L);
                               
        m_HEDlg.SetHighEditView (this);
    }
        
    return 0;
}

void CHighView::OnDestroy()
{
    CView::OnDestroy();
    
    

    delete m_pHighEdit;    
    delete m_pHETab;    
    delete m_pHERuler;    
    delete m_pBrushBk;
}

void CHighView::OnSize(UINT nType, int cx, int cy)
{                                 
    CView::OnSize(nType, cx, cy);
    
    
                      
    int x = 0, y = 0;
    
    if (m_pHERuler)
    {    
        m_pHERuler->MoveWindow (x, y, cx - x, 16, FALSE);
        y += 16;
    }    
        
    if (m_pHETab)
    {    
        m_pHETab->MoveWindow (x, y, cx - x, 16, FALSE);
        y += 16;
    }    
        
    if (m_pHighEdit)
        m_pHighEdit->MoveWindow (x, y, cx - x, cy - y, FALSE);
}

void CHighView::OnDblClk()
{
    SendMessage (HE_SELECTWORD, 0, 0L);
}    
 
void CHighView::OnTabModify() 
{
    if (m_pHETab)
    {
        LPTAB lpTab = (LPTAB) m_pHighEdit->SendMessage (HE_GETNOTIFYTABLIST, 0, 0L);

        m_pHETab->SendMessage (TM_SETTABLIST, TRUE, (LONG) lpTab);
    }
}
 
void CHighView::OnHScroll() 
{
    int iWidth = (int) m_pHighEdit->SendMessage (HE_GETNOTIFYSCROLLWIDTH, 0, 0L);
    DWORD dwScrollPos = m_pHighEdit->SendMessage (HE_GETNOTIFYHSCROLLPOS, 0, 0L);

    if (m_pHETab)
        m_pHETab->SendMessage (TM_HSCROLL, iWidth, dwScrollPos);

    if (m_pHERuler)
        m_pHERuler->SendMessage (RL_HSCROLL, iWidth, 0L);
}

void CHighView::OnFontSize()
{        
    if (GetFrameWnd()->m_pHEIcon)
    {
        COLORLOGFONT clf;

        m_pHighEdit->SendMessage (HE_GETCOLORLOGFONT, (WORD) -1, (LONG) (LPSTR) &clf);
        GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETFONTSIZE, clf.wHeight, 0L);
    }
}
        


void CHighView::OnSelectPf()
{        
	CFieldFlagsDlg cDlg;
	cDlg.m_pHighEdit = m_pHighEdit;
	cDlg.DoModal();
}



void CHighView::OnFont()
{
    if (GetFrameWnd()->m_pHEIcon)
    {
        COLORLOGFONT clf;
        
        if (m_pHighEdit->SendMessage (HE_ISSCREENFONT, (WORD) -1, 0))
        {
            m_pHighEdit->SendMessage (HE_GETSCREENCOLORLOGFONT, (WORD) -1, (LONG) (LPSTR) &clf);
            GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETCOLORLOGFONT, FONT_DISPLAY, (LONG) (LPSTR) &clf);
        }
        else
        {
            m_pHighEdit->SendMessage (HE_GETCOLORLOGFONT, (WORD) -1, (LONG) (LPSTR) &clf);
            GetFrameWnd()->m_pHEIcon->SendMessage (IBM_SETCOLORLOGFONT, FONT_PRINTER, (LONG) (LPSTR) &clf);
        }
    }    
}

void CHighView::OnCursorPos()
{                               
    CHEStatusLine *pHEStatus = GetFrameWnd()->m_pHEStatus;
    
    if (pHEStatus)
    {
        char szBuffer [16];
        
        LONG lPage = m_pHighEdit->SendMessage (HE_GETPAGE, 0, 0L);
        LONG lCursor = m_pHighEdit->SendMessage (HE_GETCURSOR, 0, 0L);

        wsprintf ((LPSTR) szBuffer, (LPSTR) "%u/%u", LOWORD (lPage) + 1, HIWORD (lPage));
        pHEStatus->SendMessage (SL_SETITEMTEXT, 4, (LONG) (LPSTR) szBuffer);
        wsprintf ((LPSTR) szBuffer, (LPSTR) "%lu", GETYPOS (lCursor) + 1L);
        pHEStatus->SendMessage (SL_SETITEMTEXT, 2, (LONG) (LPSTR) szBuffer);
        wsprintf ((LPSTR) szBuffer, (LPSTR) "%u", GETXPOS (lCursor) + 1);
        pHEStatus->SendMessage (SL_SETITEMTEXT, 0, (LONG) (LPSTR) szBuffer);
    }
}

void CHighView::OnTabInsert()
{
    BYTE byTabTyp = (BYTE) m_pHETab->SendMessage (TM_GETTYP, 0, 0L);
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);
    LONG lUnitOffset = TAB_GETUNITPOS (lReturn);
    LONG lNewOffset[2];

    lNewOffset[0] = m_pHighEdit->SendMessage (HE_INSERTTAB, byTabTyp, lUnitOffset);
    lNewOffset[1] = 0;

    m_pHETab->SendMessage (TM_SETPRINTEROFFSET, 0, (LONG) (LPLONG) lNewOffset);
}

void CHighView::OnTabUpdate()
{
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);
    LONG lNewOffset[2];

    MOVETABPARAM mtp;

    mtp.lUnitOffset = TAB_GETUNITPOS (lReturn);
    mtp.lPrinterOffset = TAB_GETPRINTERPOS (lReturn);

    m_pHighEdit->SendMessage (HE_MOVETAB, 0, (LONG) (LPSTR) &mtp);

    lNewOffset[0] = mtp.lUnitOffset;
    lNewOffset[1] = mtp.lPrinterOffset;

    m_pHETab->SendMessage (TM_SETPRINTEROFFSET, 0, (LONG) (LPLONG) lNewOffset);
}

void CHighView::OnLMUpdate()
{
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);
    LONG lNewOffset[2];

    MOVEMARGINPARAM mmp;

    mmp.lUnitOffset = TAB_GETUNITPOS (lReturn);
    mmp.lPrinterOffset = TAB_GETPRINTERPOS (lReturn);
    mmp.lIndentOffset = 0L;
    mmp.byTyp = TAB_LEFTMARGIN;

    m_pHighEdit->SendMessage (HE_MOVEMARGIN, 0, (LONG) (LPSTR) &mmp);

    lNewOffset[0] = mmp.lPrinterOffset;
    lNewOffset[1] = mmp.lIndentOffset;

    m_pHETab->SendMessage (TM_SETPRINTEROFFSET, 0, (LONG) (LPLONG) lNewOffset);
}

void CHighView::OnRMUpdate()
{
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);
    LONG lNewOffset[2];

    MOVEMARGINPARAM mmp;

    mmp.lUnitOffset = TAB_GETUNITPOS (lReturn);
    mmp.lPrinterOffset = TAB_GETPRINTERPOS (lReturn);
    mmp.lIndentOffset = 0L;
    mmp.byTyp = TAB_RIGHTMARGIN;

    m_pHighEdit->SendMessage (HE_MOVEMARGIN, 0, (LONG) (LPSTR) &mmp);

    lNewOffset[0] = mmp.lPrinterOffset;
    lNewOffset[1] = mmp.lIndentOffset;

    m_pHETab->SendMessage (TM_SETPRINTEROFFSET, 0, (LONG) (LPLONG) lNewOffset);
}

void CHighView::OnIndentUpdate()
{
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);
    LONG lNewOffset[2];

    MOVEMARGINPARAM mmp;

    mmp.lUnitOffset = TAB_GETUNITPOS (lReturn);
    mmp.lPrinterOffset = TAB_GETPRINTERPOS (lReturn);
    mmp.lIndentOffset = 0L;
    mmp.byTyp = TAB_INDENT;

    m_pHighEdit->SendMessage (HE_MOVEMARGIN, 0, (LONG) (LPSTR) &mmp);

    lNewOffset[0] = mmp.lPrinterOffset;
    lNewOffset[1] = mmp.lIndentOffset;

    m_pHETab->SendMessage (TM_SETPRINTEROFFSET, 0, (LONG) (LPLONG) lNewOffset);
}

void CHighView::OnTabDelete()
{
    LONG lReturn = m_pHETab->SendMessage (TM_GETPOS, 0, 0L);

    m_pHighEdit->SendMessage (HE_DELETETAB, 0, TAB_GETPRINTERPOS (lReturn));
}

void CHighView::OnIconDblClk()
{
    m_HEDlg.FontDlg();
    m_pHighEdit->SetFocus();
}

void CHighView::OnIconTab()
{
    if (m_pHETab)
    {
        BYTE byTabTyp = (BYTE) GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETTAB, 0, 0L);
        
        m_pHETab->SendMessage (TM_SETTYP, byTabTyp, 0L);
    }                 
    
    m_pHighEdit->SetFocus();
}
        
void CHighView::OnIconFontName()
{
    COLORLOGFONT clf;

    GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETCOLORLOGFONT, 0, (LONG) (LPSTR) &clf);

    if (GetFrameWnd()->m_pHEIcon->SendMessage (IBM_ISSCREENFONT, 0, 0L))
        m_pHighEdit->SendMessage (HE_SETCOLORLOGFONT, FONT_DISPLAY | FONT_SET_NAME, (LONG) (LPSTR) &clf);
    else
        m_pHighEdit->SendMessage (HE_SETCOLORLOGFONT, FONT_PRINTER | FONT_SET_NAME, (LONG) (LPSTR) &clf);
        
    m_pHighEdit->SetFocus();
}

void CHighView::OnIconFontSize()
{
    COLORLOGFONT clf;

    GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETCOLORLOGFONT, 0, (LONG) (LPSTR) &clf);

    if (GetFrameWnd()->m_pHEIcon->SendMessage (IBM_ISSCREENFONT, 0, 0L))
        m_pHighEdit->SendMessage (HE_SETCOLORLOGFONT, FONT_DISPLAY | FONT_SET_SIZE, (LONG) (LPSTR) &clf);
    else
        m_pHighEdit->SendMessage (HE_SETCOLORLOGFONT, FONT_PRINTER | FONT_SET_SIZE, (LONG) (LPSTR) &clf);
        
    m_pHighEdit->SetFocus();
}

void CHighView::OnIconDisplay()
{
    BOOL bDisplay = (BOOL) GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETDISPLAY, 0, 0L);

    m_pHighEdit->SendMessage (WM_SETREDRAW, FALSE, 0L);
    m_pHighEdit->SendMessage (HE_SETCRVISIBLE, bDisplay, 0L);
    m_pHighEdit->SendMessage (HE_SETSPACEVISIBLE, bDisplay, 0L);
    m_pHighEdit->SendMessage (HE_SETTABVISIBLE, bDisplay, 0L);
    m_pHighEdit->SendMessage (WM_SETREDRAW, TRUE, 0L);
    m_pHighEdit->SetFocus();
}

void CHighView::OnIconColor()
{
    m_HEDlg.m_ColorBoxParam.cr = GetFrameWnd()->SendMessage (IBM_GETCOLOR, 0, 0L);
    m_pHighEdit->SendMessage (HE_SETSTYLE, CURRENT_ATTRIBUTE, m_HEDlg.m_ColorBoxParam.cr);
    m_pHighEdit->SetFocus();
}

void CHighView::OnRulerDblClk()
{
    m_HEDlg.ParagraphDlg();
    m_pHighEdit->SetFocus();
}

void CHighView::OnFileOpen()
{
    
    
    if (m_HEDlg.LoadDlg ())
    {
        m_bUntitled = FALSE;
    }
}

void CHighView::OnFileInsert()
{
    
    
    if (m_HEDlg.AppendDlg ())
        if (m_bUntitled)
        {
            m_bUntitled = FALSE;
        }
}

void CHighView::OnSetFocus(CWnd* pOldWnd)
{
    CView::OnSetFocus(pOldWnd);
    
    

    m_pHighEdit->SetFocus();    
}

void CHighView::OnFilePrint()
{
    
         
    m_HEDlg.PrintDlg ();
}

void CHighView::OnFileInfo()
{
    
    
    m_HEDlg.DocInfoDlg ();    
}

void CHighView::OnFileSave()
{
    
    
    if (!m_bUntitled)
        m_HEDlg.SaveFile ();
    else
        if (m_HEDlg.SaveDlg ())
        {
            m_bUntitled = FALSE;
        }
}

void CHighView::OnFileSaveAs()
{
    
    
    if (m_HEDlg.SaveDlg ())
    {
        m_bUntitled = FALSE;
    }
}

void CHighView::OnWindowHeadFoot()
{
    
                                
    m_pHighEdit->SendMessage (HE_SHOWHEADFOOT, !m_pHighEdit->SendMessage (HE_ISHEADFOOTVISIBLE, 0, 0L), 0L);
}


void CHighView::OnWindowPreview() 
{
    

    m_pHighEdit->SendMessage (HE_PREVIEW, 0, 0L);    
}

void CHighView::OnEditUndo() 
{
    

    m_pHighEdit->SendMessage (HE_UNDO, 0, 0L);        
}

void CHighView::OnFilePrintSetup() 
{
    

    m_HEDlg.PrintSetupDlg ();    
}



void CHighView::OnSpecialInsertfield()
{
	CFieldInsertDlg	cDlg;
	cDlg.m_pHighEdit = m_pHighEdit;
	cDlg.DoModal();	
}



void CHighView::OnSpecialInsertTable() 
{

    CTableDlg dlgTable (this);
    
    if (dlgTable.DoModal ()==IDOK)
        m_pHighEdit->SendMessage (HE_INSERTTABLE, 0, MAKELONG (dlgTable.m_Columns, dlgTable.m_Rows));
}

void CHighView::OnSpecialInsertRow() 
{
    
                                               
    m_pHighEdit->SendMessage (HE_INSERTTABLEROW , 0, 0L);                                                
}

void CHighView::OnSpecialDeleteRow() 
{
    
    
    m_pHighEdit->SendMessage (HE_DELETETABLEROW , 0, 0L);                                                
}

/////////////////////////////////////////////////////////////////////////////


void CHighView::OnStyle()
{             
 SetStyle((BYTE) m_pHighEdit->SendMessage (HE_GETSTYLE, 0, 0L),FALSE,TRUE);
}         
        
void CHighView::OnAlign()
{
 SetAlign((BYTE) m_pHighEdit->SendMessage (HE_GETALIGN, 0, 0L),FALSE,TRUE);
}

void CHighView::OnSpacing()
{
 SetSpacing((BYTE) m_pHighEdit->SendMessage (HE_GETSPACING, 0, 0L),FALSE,TRUE);
}

void CHighView::OnIconStyle()
{
 SetStyle((BYTE) GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETSTYLE, 0, 0L),TRUE,FALSE);
 m_pHighEdit->SetFocus();
}
                           
void CHighView::OnIconSpacing()
{                           
 SetSpacing((BYTE) GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETSPACING, 0, 0L),TRUE,FALSE);
 m_pHighEdit->SetFocus();
}

void CHighView::OnIconAlign()
{
 SetAlign((BYTE) GetFrameWnd()->m_pHEIcon->SendMessage (IBM_GETALIGN, 0, 0L),TRUE,FALSE);
 m_pHighEdit->SetFocus();
}

void CHighView::OnEditClear()
{
 m_pHighEdit->SendMessage (WM_CLEAR,0,0L);
}

void CHighView::OnEditCopy()
{
 m_pHighEdit->SendMessage (WM_COPY,0,0L);
}

void CHighView::OnEditCut()
{
 m_pHighEdit->SendMessage (WM_CUT,0,0L);
}

void CHighView::OnEditPaste()
{
 m_pHighEdit->SendMessage (WM_PASTE,0,0L);
}

void CHighView::OnEditSelectAll()
{
 m_pHighEdit->SendMessage (HE_SELECTALL,0,0L);
}

void CHighView::OnFontBold()
{    
 ToggleStyle(ATTR_BOLD,TRUE,TRUE);
}

void CHighView::OnFontCenter()
{
 SetAlign(ALIGN_CENTER,TRUE,TRUE);
}

void CHighView::OnFontColor()
{
 m_HEDlg.ColorDlg();
}

void CHighView::OnFontFlushleft()
{
 SetAlign(ALIGN_LEFT,TRUE,TRUE);
}

void CHighView::OnFontFlushright()
{
 SetAlign(ALIGN_RIGHT,TRUE,TRUE);
}

void CHighView::OnFontItalic()
{
 ToggleStyle(ATTR_ITALIC,TRUE,TRUE);
}

void CHighView::OnFontJustify()
{
 SetAlign(ALIGN_JUSTIFY,TRUE,TRUE);
}

void CHighView::OnFontNewfont()
{
 m_HEDlg.FontDlg();
}

void CHighView::OnFontScreenfonts()
{
 if(m_pHighEdit->SendMessage (HE_ISSCREENFONTSENABLED, 0, 0L)) {
  m_pHighEdit->SendMessage (HE_ENABLESCREENFONTS, FALSE,0L);
  GetFrameWnd()->m_pHEIcon->SendMessage (IBM_ENABLESCREENFONTS, FALSE, 0L);
 }
 else {
  m_pHighEdit->SendMessage (HE_ENABLESCREENFONTS, TRUE,0L);
  GetFrameWnd()->m_pHEIcon->SendMessage (IBM_ENABLESCREENFONTS, TRUE, 0L);
 };
}

void CHighView::OnFontSpacingdouble()
{
 SetSpacing(SPACING_DOUBLE,TRUE,TRUE);
}

void CHighView::OnFontSpacingone()
{
 SetSpacing(SPACING_ONE,TRUE,TRUE);
}

void CHighView::OnFontSpacingonehalf()
{
 SetSpacing(SPACING_ONEHALF,TRUE,TRUE);
}

void CHighView::OnFontStandard()
{
 ToggleStyle(ATTR_STANDARD,TRUE,TRUE);
}

void CHighView::OnFontStrikeout()
{
 ToggleStyle(ATTR_STRIKEOUT,TRUE,TRUE);
}

void CHighView::OnFontSubscript()
{
 ToggleStyle(ATTR_SUBSCRIPT,TRUE,TRUE);
}

void CHighView::OnFontSuperscript()
{
 ToggleStyle(ATTR_SUPERSCRIPT,TRUE,TRUE);
}

void CHighView::OnFontUnderline()
{
 ToggleStyle(ATTR_UNDERLINE,TRUE,TRUE);
}

void CHighView::OnReplace()
{
    m_HEDlg.ReplaceDlg();
}

void CHighView::OnSearch()
{
    m_HEDlg.SearchDlg();
}                              

void CHighView::OnSearchContinue()
{
    m_HEDlg.SearchContinue(TRUE,FALSE);
}

void CHighView::OnOptBackcolor()
{
    m_HEDlg.BkColorDlg();
}

void CHighView::OnOptCrvisible()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISCRVISIBLE, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETCRVISIBLE, !bSet, 0L);
}

void CHighView::OnOptDocformat()
{
	
    m_HEDlg.FormatDocDlg();
	
}

void CHighView::OnOptGraybk()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISGRAYBK, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETGRAYBK, !bSet, 0L);
}

void CHighView::OnOptLinebreak()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISLINEBREAK, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETLINEBREAK, !bSet, 0L);
}

void CHighView::OnOptLineghost()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISLINEGHOST, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETLINEGHOST, !bSet, 0L);
}

void CHighView::OnOptParagraph()
{
    m_HEDlg.ParagraphDlg();
}

void CHighView::OnOptPffunction()
{                              

	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISPFFUNCTIONVISIBLE, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETPFFUNCTIONVISIBLE, !bSet, 0L);
}

void CHighView::OnOptPfghost()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISPFGHOST, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETPFGHOST, !bSet, 0L);
}

void CHighView::OnOptPfvisible()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISPFBKVISIBLE, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETPFBKVISIBLE, !bSet, 0L);
}

void CHighView::OnOptPictureframe()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISPICTUREFRAME, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETPICTUREFRAME, !bSet, 0L);
}

void CHighView::OnOptSaveoptions()
{
	m_pHighEdit->SendMessage (HE_WRITEPROFILE, 0, 0L);
}

void CHighView::OnOptSpacevisible()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISSPACEVISIBLE, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETSPACEVISIBLE, !bSet, 0L);
}

void CHighView::OnOptTabvisible()
{
	BOOL bSet = (BOOL) m_pHighEdit->SendMessage (HE_ISTABVISIBLE, 0, 0L);
	m_pHighEdit->SendMessage (HE_SETTABVISIBLE, !bSet, 0L);
}

void CHighView::OnOptUnitcm()
{
	m_pHERuler->SendMessage (RL_SETUNIT, UNIT_CM, 0L);
	m_pHERuler->SendMessage (TM_SETUNIT, UNIT_CM, 0L);
	m_pHighEdit->SendMessage (HE_SETUNIT, UNIT_CM, 0L);
}

void CHighView::OnOptUnitin()
{
	m_pHERuler->SendMessage (RL_SETUNIT, UNIT_IN, 0L);
	m_pHERuler->SendMessage (TM_SETUNIT, UNIT_IN, 0L);
	m_pHighEdit->SendMessage (HE_SETUNIT, UNIT_IN, 0L);
}

void CHighView::OnSpecialFormat()
{
	m_pHighEdit->SendMessage (HE_FORMAT, 0, 0L);
}

void CHighView::OnSpecialFormfeed()
{
	m_pHighEdit->SendMessage (HE_FORMFEED, 0, 0L);
}

void CHighView::OnSpecialInsertpicture()
{
	
    m_HEDlg.PictureDlg();
	
}

void CHighView::OnSpecialPaginate()
{
	m_pHighEdit->SendMessage (HE_PAGINATE, 0, 0L);
}

void CHighView::OnWindowCloseall()
{
	

}

void CHighView::OnUpdateFontBold(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_BOLD);	
}

void CHighView::OnUpdateFontCenter(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byAlign==ALIGN_CENTER);	
}

void CHighView::OnUpdateFontFlushleft(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byAlign==ALIGN_LEFT);	
}

void CHighView::OnUpdateFontFlushright(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byAlign==ALIGN_RIGHT);	
}

void CHighView::OnUpdateFontItalic(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_ITALIC);	
}

void CHighView::OnUpdateFontJustify(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byAlign==ALIGN_JUSTIFY);	
}

void CHighView::OnUpdateFontSpacingdouble(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(bySpacing==SPACING_DOUBLE);	
}

void CHighView::OnUpdateFontSpacingone(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(bySpacing==SPACING_ONE);	
}

void CHighView::OnUpdateFontSpacingonehalf(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(bySpacing==SPACING_ONEHALF);	
}

void CHighView::OnUpdateFontStrikeout(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_STRIKEOUT);	
}

void CHighView::OnUpdateFontSubscript(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_SUBSCRIPT);	
}

void CHighView::OnUpdateFontSuperscript(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_SUPERSCRIPT);	
}

void CHighView::OnUpdateFontUnderline(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck(byStyle & ATTR_UNDERLINE);	
}

void CHighView::OnUpdateFontScreenfonts(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISSCREENFONTSENABLED, 0, 0L));
}

void CHighView::OnUpdateOptGraybk(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISGRAYBK, 0, 0L));
}

void CHighView::OnUpdateOptCrvisible(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISCRVISIBLE, 0, 0L));
}

void CHighView::OnUpdateOptSpacevisible(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISSPACEVISIBLE, 0, 0L));
}

void CHighView::OnUpdateOptTabvisible(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISTABVISIBLE, 0, 0L));
}

void CHighView::OnUpdateOptUnitcm(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_GETUNIT, 0, 0L)==UNIT_CM);
}

void CHighView::OnUpdateOptUnitin(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_GETUNIT, 0, 0L)==UNIT_IN);
}

void CHighView::OnUpdateOptPictureframe(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISPICTUREFRAME, 0, 0L));
}

void CHighView::OnUpdateOptPfvisible(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISPFBKVISIBLE, 0, 0L));
}

void CHighView::OnUpdateOptPfghost(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISPFGHOST, 0, 0L));
}

void CHighView::OnUpdateOptPffunction(CCmdUI* pCmdUI)
{                
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISPFFUNCTIONVISIBLE, 0, 0L));
}

void CHighView::OnUpdateOptLinebreak(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISLINEBREAK, 0, 0L));
}

void CHighView::OnUpdateOptLineghost(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISLINEGHOST, 0, 0L));
}

void CHighView::OnUpdateWindowHeadfoot(CCmdUI* pCmdUI)
{
 pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISHEADFOOTVISIBLE, 0, 0L));
};

void CHighView::OnUpdateWindowPreview(CCmdUI* pCmdUI)
{
   pCmdUI->SetCheck((int)m_pHighEdit->SendMessage (HE_ISPREVIEW, 0, 0L));
};

void CHighView::OnUpdateEditUndo(CCmdUI* pCmdUI)
{
 pCmdUI->Enable((int)m_pHighEdit->SendMessage (HE_CANUNDO, 0, 0L));
};




