// highvw.h : interface of the CHighView class
//
/////////////////////////////////////////////////////////////////////////////

class CHighView : public CView
{             
public:
    CHighEdit *m_pHighEdit;
    CHETabulator *m_pHETab;
    CHERuler *m_pHERuler;
    CBrush *m_pBrushBk;
    
    CHEDialogBoxes m_HEDlg;
    
    BOOL m_bUntitled;

	BYTE byAlign;
	BYTE byStyle;
	BYTE bySpacing;
            
protected: // create from serialization only
    CHighView();
    DECLARE_DYNCREATE(CHighView)

    virtual void SetAlign(BYTE Align,BOOL HighEdit,BOOL IconBar);
    virtual void SetStyle(BYTE Style,BOOL HighEdit,BOOL IconBar);
    virtual void ToggleStyle(BYTE Style,BOOL HighEdit,BOOL IconBar);
    virtual void SetSpacing(BYTE Spacing,BOOL HighEdit,BOOL IconBar);

// Attributes
public:
    CHighDoc* GetDocument();

// Operations
public:

    BOOL LoadFile();
        
// Implementation
public:
    virtual ~CHighView();
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif


// Generated message map functions
protected:
    //{{AFX_MSG(CHighView)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnDestroy();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnDblClk();
    afx_msg void OnTabModify();
    afx_msg void OnHScroll();
    afx_msg void OnFontSize();
    afx_msg void OnFont();
    afx_msg void OnSelectPf();
    afx_msg void OnCursorPos();
    afx_msg void OnTabInsert();
    afx_msg void OnTabUpdate();
    afx_msg void OnLMUpdate();
    afx_msg void OnRMUpdate();
    afx_msg void OnIndentUpdate();
    afx_msg void OnTabDelete();
    afx_msg void OnIconDblClk();
    afx_msg void OnIconTab();
    afx_msg void OnIconFontName();
    afx_msg void OnIconFontSize();
    afx_msg void OnIconDisplay();
    afx_msg void OnIconColor();
    afx_msg void OnRulerDblClk();
    afx_msg void OnFileOpen();
    afx_msg void OnFileInsert();
    afx_msg void OnSetFocus(CWnd* pOldWnd);
    afx_msg void OnFilePrint();
    afx_msg void OnFileInfo();
    afx_msg void OnFileSave();
    afx_msg void OnFileSaveAs();
    afx_msg void OnWindowHeadFoot();
    afx_msg void OnWindowPreview();
    afx_msg void OnEditUndo();
    afx_msg void OnFilePrintSetup();
	afx_msg void OnSpecialInsertTable();
	afx_msg void OnSpecialInsertRow();
	afx_msg void OnSpecialDeleteRow();
   afx_msg void OnStyle();
   afx_msg void OnAlign();
   afx_msg void OnSpacing();
   afx_msg void OnIconStyle();
   afx_msg void OnIconSpacing();
   afx_msg void OnIconAlign();
	afx_msg void OnEditClear();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnEditSelectAll();
	afx_msg void OnFontBold();
	afx_msg void OnFontCenter();
	afx_msg void OnFontColor();
	afx_msg void OnFontFlushleft();
	afx_msg void OnFontFlushright();
	afx_msg void OnFontItalic();
	afx_msg void OnFontJustify();
	afx_msg void OnFontNewfont();
	afx_msg void OnFontScreenfonts();
	afx_msg void OnFontSpacingdouble();
	afx_msg void OnFontSpacingone();
	afx_msg void OnFontSpacingonehalf();
	afx_msg void OnFontStandard();
	afx_msg void OnFontStrikeout();
	afx_msg void OnFontSubscript();
	afx_msg void OnFontSuperscript();
	afx_msg void OnFontUnderline();
	afx_msg void OnReplace();
	afx_msg void OnSearch();
	afx_msg void OnSearchContinue();
	afx_msg void OnOptBackcolor();
	afx_msg void OnOptCrvisible();
	afx_msg void OnOptDocformat();
	afx_msg void OnOptGraybk();
	afx_msg void OnOptLinebreak();
	afx_msg void OnOptLineghost();
	afx_msg void OnOptParagraph();
	afx_msg void OnOptPffunction();
	afx_msg void OnOptPfghost();
	afx_msg void OnOptPfvisible();
	afx_msg void OnOptPictureframe();
	afx_msg void OnOptSaveoptions();
	afx_msg void OnOptSpacevisible();
	afx_msg void OnOptTabvisible();
	afx_msg void OnOptUnitcm();
	afx_msg void OnOptUnitin();
	afx_msg void OnSpecialAddress();
	afx_msg void OnSpecialFieldinsert();
	afx_msg void OnSpecialFormat();
	afx_msg void OnSpecialFormfeed();
	afx_msg void OnSpecialInsertpicture();
	afx_msg void OnSpecialPaginate();
	afx_msg void OnWindowCloseall();
	afx_msg void OnUpdateFontBold(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontCenter(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontFlushleft(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontFlushright(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontItalic(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontJustify(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontSpacingdouble(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontSpacingone(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontSpacingonehalf(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontStrikeout(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontSubscript(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontSuperscript(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontUnderline(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontScreenfonts(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptGraybk(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptCrvisible(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptSpacevisible(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptTabvisible(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptUnitcm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptUnitin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptPictureframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptPfvisible(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptPfghost(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptPffunction(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptLinebreak(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptLineghost(CCmdUI* pCmdUI);
	afx_msg void OnUpdateWindowHeadfoot(CCmdUI* pCmdUI);
	afx_msg void OnUpdateWindowPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnSpecialInsertfield();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in highvw.cpp
inline CHighDoc* CHighView::GetDocument()
   { return (CHighDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
