VERSION 2.00
Begin Form frmWaveMix 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "VB WaveMix Demo"
   ClientHeight    =   2070
   ClientLeft      =   3300
   ClientTop       =   2415
   ClientWidth     =   4035
   ControlBox      =   0   'False
   Height          =   2535
   Icon            =   VBWAVMIX.FRX:0000
   Left            =   3210
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2070
   ScaleWidth      =   4035
   Top             =   2040
   Width           =   4215
   Begin CommandButton cmdAbout 
      Caption         =   "&About"
      Height          =   375
      Left            =   2760
      TabIndex        =   8
      Top             =   600
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &8"
      Height          =   375
      Index           =   7
      Left            =   1320
      TabIndex        =   7
      Top             =   1560
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &7"
      Height          =   375
      Index           =   6
      Left            =   1320
      TabIndex        =   6
      Top             =   1080
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &6"
      Height          =   375
      Index           =   5
      Left            =   1320
      TabIndex        =   5
      Top             =   600
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &5"
      Height          =   375
      Index           =   4
      Left            =   1320
      TabIndex        =   4
      Top             =   120
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &4"
      Height          =   375
      Index           =   3
      Left            =   120
      TabIndex        =   3
      Top             =   1560
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &3"
      Height          =   375
      Index           =   2
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &2"
      Height          =   375
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   1095
   End
   Begin CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   2760
      TabIndex        =   9
      Top             =   120
      Width           =   1095
   End
   Begin CommandButton cmdWave 
      Caption         =   "Wave &1"
      Height          =   375
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
'****************************************************************************
'                Sample VB code for using the WAVEMIX.DLL
'             Copyright  1994 by Rob McGregor.  Use freely.
'============================================================================
'  File     : VBWAVMIX.FRM
'
'  Author   : Rob McGregor
'             Screaming Tiki Software
'             Cocoa, FL, USA
'             CIS 73122,3125
'
'  Comments : This file demonstrates how to use the WaveMix Library in
'             Visual Basic. The wave filenames specified in the Form_Load
'             event should be changed to waves available on *your* system...
'             Hope this helps some of you out there floundering on this
'             stuff!
'****************************************************************************

Option Explicit

Const MAXWAVES = 7             ' 0-7  (WaveMix supports up to 8 waves at a time)

Dim WaveMixConfig As MIXCONFIG ' MIXCONFIG structure
Dim hMixSession%               ' Handle to the current mix session
Dim asWave$(MAXWAVES)          ' An array of wave filenames
Dim alpWave&(MAXWAVES)         ' An array that stores return values from WaveMixOpenWave

Sub cmdAbout_Click ()
  frmAbout.Show 1
End Sub

Sub cmdClose_Click ()
  Unload Me
End Sub

Sub cmdWave_Click (Index As Integer)
  Dim ret%, MixPlayParam As MIXPLAYPARAMS

  ' Command button array index corresponds to wave array index
  MixPlayParam.wSize = Len(MixPlayParam)    ' sizeof (MIXPLAYPARAMS)
  MixPlayParam.hMixSession = hMixSession
  MixPlayParam.iChannel = Index
  MixPlayParam.lpMixWave = alpWave(Index)
  MixPlayParam.hWndNotify = 0
  MixPlayParam.dwFlags = WMIX_HIGHPRIORITY
  MixPlayParam.wLoops = 0
  
  ' Add the selected wave to the mix & play it
  ret = WaveMixPlay(MixPlayParam)

End Sub

Sub Form_Activate ()
    Dim ret As Integer

    ret = WaveMixActivate(hMixSession, True)
    End Sub

Sub Form_Deactivate ()
    Dim ret As Integer

    ret = WaveMixActivate(hMixSession, False)
    End Sub

Sub Form_Load ()
  Dim i%, ret%, sMsg$

  ' center the form on the screen
  Me.Move screen.Width \ 2 - Me.Width \ 2, screen.Height \ 2 - Me.Height \ 2

  ' Initialize the MIXCONFIG structure
  WaveMixConfig.wSize = Len(WaveMixConfig)
  WaveMixConfig.dwFlags = WMIX_CONFIG_CHANNELS Or WMIX_CONFIG_SAMPLINGRATE
  WaveMixConfig.wChannels = 2
  WaveMixConfig.wSamplingRate = 11
  
  ' Get a handle to the mix session
  hMixSession = WaveMixConfigureInit(WaveMixConfig)
  
  ' Set up an array of waves (can be any wave files you wanna use...)
  asWave(0) = "c:\wavemix\1.wav"
  asWave(1) = "c:\wavemix\2.wav"
  asWave(2) = "c:\wavemix\3.wav"
  asWave(3) = "c:\wavemix\4.wav"
  asWave(4) = "c:\wavemix\5.wav"
  asWave(5) = "c:\wavemix\6.wav"
  asWave(6) = "c:\wavemix\7.wav"
  asWave(7) = "c:\wavemix\8.wav"
  
  ' Open all of the wave files
  For i = 0 To MAXWAVES
    alpWave(i) = WaveMixOpenWave(hMixSession, asWave(i), 0, WMIX_FILE)
  Next i
  
  ' Attempt to access all the wave channels
  ret = WaveMixOpenChannel(hMixSession, 0, WMIX_ALL)
  
  If (ret) Then
    sMsg = GetWaveChannelError(ret)
    MsgBox sMsg, 16, "WaveMix Error"
    Unload Me
  End If
  
  ' OK, we made it this far, so start mixing!
  ret = WaveMixActivate(hMixSession, True)

End Sub

Sub Form_Unload (Cancel As Integer)
  Dim ret%, i%

  ret = WaveMixCloseChannel(hMixSession, 0, WMIX_ALL)
  
  For i = 0 To MAXWAVES
    alpWave(i) = WaveMixFreeWave(hMixSession, alpWave(i))
  Next
  
  ret = WaveMixCloseSession(hMixSession)
  End

End Sub

